Backend API
<template>
<DxDiagram
id="diagram"
ref="diagram"
>
<DxToolbox :visible="true">
<DxGroup
:category="'general'"
:title="'General'"
/>
<DxGroup
:category="'containers'"
:title="'Containers'"
:expanded="true"
/>
</DxToolbox>
</DxDiagram>
</template>
<script setup lang="ts">
import { watch, ref } from 'vue';
import { DxDiagram, DxToolbox, DxGroup } from 'devextreme-vue/diagram';
import 'whatwg-fetch';
const diagram = ref();
watch(diagram,
({ instance }) => {
fetch('../../../../data/diagram-structure.json')
.then((response) => response.json())
.then((json) => {
instance.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
});
</script>
<style scoped>
#diagram {
height: 725px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
{
"page": {
"width": 11910,
"height": 8400,
"pageColor": "white",
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": true,
"units": 0
},
"connectors": [],
"shapes": [
{
"key": "0",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Development",
"x": 720,
"y": 720,
"width": 10440.000000000002,
"height": 7020,
"childKeys": [ "1", "2", "4", "3" ]
},
{
"key": "1",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "ASP.NET Team",
"x": 1080,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "5", "6" ]
},
{
"key": "2",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Javascript Team",
"x": 3600,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "7", "8" ]
},
{
"key": "3",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WPF Team",
"x": 6120,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "9", "10", "11" ]
},
{
"key": "4",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WinForms Team",
"x": 8640,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "12", "13" ]
},
{
"key": "5",
"dataKey": "119",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Laurence\nLebihan",
"x": 1440,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "6",
"dataKey": "120",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Elizabeth\nLincoln",
"x": 1440,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "7",
"dataKey": "122",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Patricio\nSimpson",
"x": 3960,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "8",
"dataKey": "123",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Francisco\nChang",
"x": 3960,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "9",
"dataKey": "115",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Christina\nBerglund",
"x": 6480,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "10",
"dataKey": "116",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Hanna\nMoos",
"x": 6480,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "11",
"dataKey": "117",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Frederique\nCiteaux",
"x": 6480,
"y": 5040,
"width": 1440,
"height": 1080
},
{
"key": "12",
"dataKey": "112",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Ana\nTrujillo",
"x": 9000,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "13",
"dataKey": "113",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Antonio\nMoreno",
"x": 9000,
"y": 3600,
"width": 1440,
"height": 1080
}
]
}

Backend API
<dx-diagram #diagram id="diagram">
<dxo-diagram-toolbox>
<dxi-diagram-group category="general" title="General"></dxi-diagram-group>
<dxi-diagram-group
category="containers"
title="Containers"
[expanded]="true"
></dxi-diagram-group>
</dxo-diagram-toolbox>
</dx-diagram>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { DxDiagramModule, DxDiagramComponent } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxDiagramModule,
],
})
export class AppComponent {
@ViewChild(DxDiagramComponent, { static: false }) diagram: DxDiagramComponent;
constructor(http: HttpClient) {
http.get('../../../../data/diagram-structure.json').subscribe({
next: (data) => { this.diagram.instance.import(JSON.stringify(data)); },
error: () => { throw new Error('Data Loading Error'); },
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #diagram {
height: 725px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
{
"page": {
"width": 11910,
"height": 8400,
"pageColor": "white",
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": true,
"units": 0
},
"connectors": [],
"shapes": [
{
"key": "0",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Development",
"x": 720,
"y": 720,
"width": 10440.000000000002,
"height": 7020,
"childKeys": [ "1", "2", "4", "3" ]
},
{
"key": "1",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "ASP.NET Team",
"x": 1080,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "5", "6" ]
},
{
"key": "2",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Javascript Team",
"x": 3600,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "7", "8" ]
},
{
"key": "3",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WPF Team",
"x": 6120,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "9", "10", "11" ]
},
{
"key": "4",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WinForms Team",
"x": 8640,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "12", "13" ]
},
{
"key": "5",
"dataKey": "119",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Laurence\nLebihan",
"x": 1440,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "6",
"dataKey": "120",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Elizabeth\nLincoln",
"x": 1440,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "7",
"dataKey": "122",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Patricio\nSimpson",
"x": 3960,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "8",
"dataKey": "123",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Francisco\nChang",
"x": 3960,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "9",
"dataKey": "115",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Christina\nBerglund",
"x": 6480,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "10",
"dataKey": "116",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Hanna\nMoos",
"x": 6480,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "11",
"dataKey": "117",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Frederique\nCiteaux",
"x": 6480,
"y": 5040,
"width": 1440,
"height": 1080
},
{
"key": "12",
"dataKey": "112",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Ana\nTrujillo",
"x": 9000,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "13",
"dataKey": "113",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Antonio\nMoreno",
"x": 9000,
"y": 3600,
"width": 1440,
"height": 1080
}
]
}

Backend API
import React, { useEffect, useRef } from 'react';
import Diagram, { Group, Toolbox } from 'devextreme-react/diagram';
import type { DiagramRef } from 'devextreme-react/diagram';
import 'whatwg-fetch';
export default function App() {
const diagramRef = useRef<DiagramRef>(null);
useEffect(() => {
const diagram = diagramRef?.current?.instance();
fetch('../../../../data/diagram-structure.json')
.then((response) => response.json())
.then((json) => {
diagram?.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
}, []);
return (
<Diagram id="diagram" ref={diagramRef}>
<Toolbox>
<Group category="general" title="General" />
<Group category="containers" title="Containers" expanded={true} />
</Toolbox>
</Diagram>
);
}
import React, { useEffect, useRef } from 'react';
import Diagram, { Group, Toolbox } from 'devextreme-react/diagram';
import 'whatwg-fetch';
export default function App() {
const diagramRef = useRef(null);
useEffect(() => {
const diagram = diagramRef?.current?.instance();
fetch('../../../../data/diagram-structure.json')
.then((response) => response.json())
.then((json) => {
diagram?.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
}, []);
return (
<Diagram
id="diagram"
ref={diagramRef}
>
<Toolbox>
<Group
category="general"
title="General"
/>
<Group
category="containers"
title="Containers"
expanded={true}
/>
</Toolbox>
</Diagram>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
{
"page": {
"width": 11910,
"height": 8400,
"pageColor": "white",
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": true,
"units": 0
},
"connectors": [],
"shapes": [
{
"key": "0",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Development",
"x": 720,
"y": 720,
"width": 10440.000000000002,
"height": 7020,
"childKeys": [ "1", "2", "4", "3" ]
},
{
"key": "1",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "ASP.NET Team",
"x": 1080,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "5", "6" ]
},
{
"key": "2",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "Javascript Team",
"x": 3600,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "7", "8" ]
},
{
"key": "3",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WPF Team",
"x": 6120,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "9", "10", "11" ]
},
{
"key": "4",
"locked": false,
"zIndex": 0,
"type": "verticalContainer",
"text": "WinForms Team",
"x": 8640,
"y": 1440,
"width": 2160,
"height": 5760,
"childKeys": [ "12", "13" ]
},
{
"key": "5",
"dataKey": "119",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Laurence\nLebihan",
"x": 1440,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "6",
"dataKey": "120",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Elizabeth\nLincoln",
"x": 1440,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "7",
"dataKey": "122",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Patricio\nSimpson",
"x": 3960,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "8",
"dataKey": "123",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Francisco\nChang",
"x": 3960,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "9",
"dataKey": "115",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Christina\nBerglund",
"x": 6480,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "10",
"dataKey": "116",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Hanna\nMoos",
"x": 6480,
"y": 3600,
"width": 1440,
"height": 1080
},
{
"key": "11",
"dataKey": "117",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Frederique\nCiteaux",
"x": 6480,
"y": 5040,
"width": 1440,
"height": 1080
},
{
"key": "12",
"dataKey": "112",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Ana\nTrujillo",
"x": 9000,
"y": 2160,
"width": 1440,
"height": 1080
},
{
"key": "13",
"dataKey": "113",
"locked": false,
"zIndex": 0,
"type": "rectangle",
"text": "Antonio\nMoreno",
"x": 9000,
"y": 3600,
"width": 1440,
"height": 1080
}
]
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#diagram {
height: 725px;
}